﻿<!-----------------------------------------------------------------------
Author 	 :	Curt Gratz
Date     :	Feb 2nd, 2010
Description :
	This is a ColdBox event handler for general methods.

Please note that the extends needs to point to the eventhandler.cfc
in the ColdBox system directory.
extends = coldbox.system.EventHandler

----------------------------------------------------------------------->
<cfcomponent name="general" extends="coldbox.system.EventHandler" output="false">

	<cffunction name="init" access="public" returntype="any" output="false">
		<cfargument name="controller" type="any"/>

		<cfset super.init(arguments.controller)/>

		<cfreturn this>
	</cffunction>

	<cffunction name="index" returntype="void" output="false" hint="I am a slow event that gets cached" cache="true" cacheTimeout="30">
		<cfargument name="event" required="true">
		<cfset var rc = event.getCollection()>

		<cfif not isdefined("rc.cacheTest")>
			<cfset rc.cacheTest = "I'm used for testing event cache under load">
		</cfif>

		<!--- set the view to an none view so we aren't concerned about anything but view rendering --->

		<cfset Event.setLayout("Layout.None")>


		<!--- just show the slowEvent, expects a URL variable sent to the request collection called cacheTest --->
		<cfset Event.setView("slowEvent")>
	</cffunction>

	<cffunction name="ClearEvents" returntype="void" output="false" hint="I run the clear all events coldbox setting to get events out of cache">
		<cfargument name="event" required="true" type="any">
		<cfscript>
			var rc = event.getCollection();
			//Clear all events from cache
			getCache().clearAllEvents();

			event.renderData(type="Plain",data="Events have been cleared from cache");
		</cfscript>
	</cffunction>

</cfcomponent>